NIP-16
======

Event Treatment
---------------

`draft` `optional` `author:Semisol`

Relays may decide to allow replaceable and/or ephemeral events.

Replaceable Events
------------------
A *replaceable event* is defined as an event with a `replaceable` tag with value `1`. Relays SHOULD treat unknown types as if the event is not replaceable.  
Upon a replaceable event with a newer timestamp than the currently known latest replaceable event with the same kind, the old event SHOULD be discarded and replaced with the newer event.

Ephemeral Events
----------------
An *ephemeral event* is defined as an event with an `ephemeral` tag with value `1`. Relays are RECOMMENDED to reject unknown types for future extensions.  
Upon an ephemeral event being received, the relay SHOULD send it to all clients with a matching filter, and MUST NOT store it.

Client Behavior
---------------

Clients SHOULD use the `supported_nips` field to learn if a relay supports generic tag queries.  Clients SHOULD NOT send ephemeral events to relays that do not support this NIP; they will be persisted.  Clients MAY send replaceable events to relays that may not support this NIP, and clients querying SHOULD be prepared for the relay to send multiple events and should use the latest one.  

Clients are RECOMMENDED to ignore events without replaceability when requesting replaceable events.

Suggested Use Cases
-------------------

* States: An application may create a state event that is replaced every time a new state is set (such as statuses)
* Typing indicators: A chat application may use ephemeral events as a typing indicator.
* Messaging: Two pubkeys can message over nostr using ephemeral events.
